"use strict";
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CloudFormationRegionProcessor = exports.LOCATION_TYPE = void 0;
const plugin_catalog_backend_1 = require("@backstage/plugin-catalog-backend");
const CloudFormationProcessor_1 = require("../CloudFormationProcessor");
const CloudFormationStackProcessor_1 = require("../CloudFormationStackProcessor/CloudFormationStackProcessor");
const loadLocations_1 = require("./loadLocations");
const parseTarget_1 = require("./parseTarget");
exports.LOCATION_TYPE = 'aws:cloudformation:region';
class CloudFormationRegionProcessor extends CloudFormationProcessor_1.CloudFormationProcessor {
    constructor(config) {
        super(config);
    }
    getProcessorName() {
        return 'CloudFormationRegionProcessor';
    }
    async readLocation(location, _optional, emit) {
        var e_1, _a;
        if (location.type !== exports.LOCATION_TYPE) {
            return false;
        }
        try {
            const { region, profile = this.profile } = (0, parseTarget_1.parseTarget)(location.target);
            if (typeof region === 'undefined') {
                throw new Error('Location target format is incorrect. Region was not matched. Correct target format is "profile@region"');
            }
            try {
                for (var _b = __asyncValues((0, loadLocations_1.loadLocationsFromCloudFormation)({
                    region,
                    profile
                })), _c; _c = await _b.next(), !_c.done;) {
                    const stackId = _c.value;
                    emit(plugin_catalog_backend_1.processingResult.location({
                        target: `${profile}@${stackId}`,
                        type: CloudFormationStackProcessor_1.LOCATION_TYPE
                    }));
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) await _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        catch (e) {
            const message = `${location.type} ${location.target} could not be read, ${e}`;
            emit(plugin_catalog_backend_1.processingResult.generalError(location, message));
        }
        return true;
    }
}
exports.CloudFormationRegionProcessor = CloudFormationRegionProcessor;
//# sourceMappingURL=CloudFormationRegionProcessor.js.map