"use strict";
var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadLocationsFromCloudFormation = void 0;
const aws_sdk_1 = __importDefault(require("aws-sdk"));
function loadLocationsFromCloudFormation(target) {
    var _a;
    return __asyncGenerator(this, arguments, function* loadLocationsFromCloudFormation_1() {
        const cloudFormation = new aws_sdk_1.default.CloudFormation({
            credentials: new aws_sdk_1.default.SharedIniFileCredentials({
                profile: target.profile
            }),
            region: target.region
        });
        let nextToken = undefined;
        do {
            const params = {
                StackStatusFilter: [
                    'CREATE_IN_PROGRESS',
                    'CREATE_COMPLETE',
                    'ROLLBACK_IN_PROGRESS',
                    'ROLLBACK_COMPLETE',
                    'UPDATE_IN_PROGRESS',
                    'UPDATE_COMPLETE_CLEANUP_IN_PROGRESS',
                    'UPDATE_COMPLETE',
                    'UPDATE_ROLLBACK_IN_PROGRESS',
                    'UPDATE_ROLLBACK_FAILED',
                    'UPDATE_ROLLBACK_COMPLETE_CLEANUP_IN_PROGRESS',
                    'UPDATE_ROLLBACK_COMPLETE',
                    'IMPORT_IN_PROGRESS',
                    'IMPORT_COMPLETE',
                    'IMPORT_ROLLBACK_IN_PROGRESS',
                    'IMPORT_ROLLBACK_FAILED',
                    'IMPORT_ROLLBACK_COMPLETE'
                ]
            };
            if (nextToken) {
                params.NextToken = nextToken;
            }
            const stacks = yield __await(cloudFormation.listStacks(params).promise());
            for (const { StackId } of (_a = stacks.StackSummaries) !== null && _a !== void 0 ? _a : []) {
                if (typeof StackId !== 'undefined') {
                    yield yield __await(StackId);
                }
            }
            nextToken = stacks.NextToken;
        } while (typeof nextToken === 'string');
    });
}
exports.loadLocationsFromCloudFormation = loadLocationsFromCloudFormation;
//# sourceMappingURL=loadLocations.js.map